SystemOrganization addCategory: #BBCRadioRecorder!

Object subclass: #BBCEpisode
	instanceVariableNames: 'brandElement episodeElement seriesElement brandPid brandTitle brandPosition brandChildCount seriesPid seriesTitle seriesPosition seriesChildCount episodePid episodeTitle episodePosition episodeSynopsisShort episodeDuration canonicalPid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCEpisode commentStamp: 'jrm 2/6/2015 17:11' prior: 0!
#BBCEpisode is a class that manages the information about a program require to listen to or record a program episode.. It is an object used to provide the information required to build a command to be used to record a BBC radio stream. The XML contents for an episode, schedule or  genra sources are different. I have identified the common elements in all three, and built this class using them.

Instance Variables

canonicalPid - required to determine mediaSelector url
brandElement - anXML
episodeElement 
seriesElement 
episodePid 
episodeDuration 
episodePosition 
episodeSynopsisShort 
episodeTitle 
brandChildCount 
brandPid 
brandPosition 
brandTitle 
seriesChildCount 
seriesPosition 
seriesTitle 
seriesPid
!

!BBCEpisode class methodsFor: 'as yet unclassified' stamp: 'jrm 1/31/2015 13:47'!
newFrom: anEpisodePid

	|  |

	self halt.
! !

!BBCEpisode class methodsFor: 'as yet unclassified' stamp: 'jrm 2/1/2015 20:22'!
newFromEpisode: anEpisodePid

	|  |

	self halt.
! !

!BBCEpisode class methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 13:50'!
newFromGenra: aGenraString

"'Build a url from the drama string"

"BBCEpisode newFromGenra: 'drama/scifiandfantasy'"
^(self new) newGenraFrom:  'http://www.bbc.co.uk/radio/programmes/genres/',aGenraString,'/player/episodes.xml'.! !

!BBCEpisode class methodsFor: 'as yet unclassified' stamp: 'jrm 2/1/2015 20:23'!
newFromSchedule: aGenraString

"'Build a url from a schedule"

"BBCEpisode newFromSchedule: 'tbd'"
^(self new) newGenraFrom:  'http://www.bbc.co.uk/radio/tbd'.! !

!BBCEpisode methodsFor: 'as yet unclassified' stamp: 'jrm 1/15/2015 22:12'!
addProgrammeFrom: anElement

	|  |
	episodeElement := anElement firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'episode'].
	seriesElement := episodeElement firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'series'].
	brandElement  := episodeElement firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'brand'].


episodePid := episodeElement contentStringAt: #pid.
episodePosition := episodeElement contentStringAt: #position.
episodeTitle := episodeElement contentStringAt: #title.
episodeSynopsisShort := episodeElement contentStringAt: 'short_synopsis'.
episodeDuration := episodeElement contentStringAt: #duration.

seriesElement = nil ifFalse: [
seriesPid := seriesElement contentStringAt: #pid.
seriesPosition := seriesElement contentStringAt: #position.
seriesTitle := seriesElement contentStringAt: #title.
seriesChildCount := seriesElement contentStringAt: 'expected_child_count'].
brandElement = nil ifFalse: [
brandPid := brandElement contentStringAt: #pid.
brandPosition := brandElement contentStringAt: #position.
brandTitle := brandElement contentStringAt: #title.
brandChildCount := brandElement contentStringAt: 'expected_child_count'].
^ self! !

!BBCEpisode methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 14:56'!
newFrom: anXMLElement
	"comment stating purpose of message"

		|  |
	
	self addProgrammeFrom: anXMLElement
! !

Object subclass: #BBCEpisodeRecorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCEpisodeRecorder commentStamp: 'jrm 1/24/2015 22:21' prior: 0!
A BBCEpisodeRecorder is the interface to the ffmpeg programs that I need to implement the recording of a program. This is being built because OSProcess is not quite up to the task, or I don't know how to make it work the way I want. This clas should do what I need done, which is to run a series of programs and clean up after itself. The MediaSelector for BBC episodes offers 1 or more stream options, usually WAV or AAC. I prefer to use AAC, but if it is not available, then I will use WAV.

The WAV stream is recorded in real time the ACC stream is downloaded and quickly..

Instance Variables none yet.
!

!BBCEpisodeRecorder class methodsFor: 'sandbox' stamp: 'jrm 9/21/2014 21:28'!
dumpString: cmd1 copyString: cmd2
	"based on sandbox2"

| aFileName anSFS  aFileName2 anSFS2 osp1 osp2 osp3 osp4 aFileName3 anSFS3 osp5 osp6 |
aFileName := '/Volumes/MediaVault/BBC/test.sh'.
anSFS := StandardFileStream newFileNamed: aFileName.
anSFS nextPutAll:  '#!!/bin/sh', Character lf, ' ', cmd1, Character lf.
anSFS close.

osp1 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName).
"self halt." "NOTE: The code seems to work with a halt. Let's try a short delay"
(Delay forSeconds: 2) wait.
osp2 := ExternalUnixOSProcess exec: aFileName.
(Delay forSeconds: 30) wait.                 "there was a halt here too"
aFileName2 := '/Volumes/MediaVault/BBC/test2.sh'.
anSFS2 := StandardFileStream newFileNamed: aFileName2.
anSFS2 nextPutAll:  '#!!/bin/sh', Character lf , ' ',  cmd2.

osp3 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName2).
(Delay forSeconds: 2) wait.
osp4 := ExternalUnixOSProcess exec: aFileName2.
(Delay forSeconds: 3) wait.

aFileName3 := '/Volumes/MediaVault/BBC/test3.sh'.
anSFS3 := StandardFileStream newFileNamed: aFileName3.
anSFS3 nextPutAll:  '#!!/bin/sh', Character lf, 
'rm /Volumes/MediaVault/BBC/243594461.flv; rm /Volumes/MediaVault/BBC/test.sh; rm /Volumes/MediaVault/BBC/test2.sh ; rm /Volumes/MediaVault/BBC/test3.sh '.

osp5 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName3).
(Delay forSeconds: 3) wait.
osp6 := ExternalUnixOSProcess forkAndExec: aFileName3.
self halt.
^ self! !

!BBCEpisodeRecorder class methodsFor: 'sandbox' stamp: 'jrm 9/22/2014 20:25'!
dumpString: cmd1 copyString: cmd2 fileName: fileName
	"based on sandbox2"

| aFileName anSFS  aFileName2 anSFS2 osp1 osp2 osp3 osp4 aFileName3 anSFS3 osp5 osp6 |
aFileName := '/Volumes/MediaVault/BBC/test.sh'.
anSFS := StandardFileStream newFileNamed: aFileName.
anSFS nextPutAll:  '#!!/bin/sh', Character lf, ' ', cmd1, Character lf.
anSFS close.

osp1 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName).
"self halt." "NOTE: The code seems to work with a halt. Let's try a short delay"
(Delay forSeconds: 2) wait.
osp2 := ExternalUnixOSProcess exec: aFileName.
(Delay forSeconds: 30) wait.                 "there was a halt here too"
aFileName2 := '/Volumes/MediaVault/BBC/test2.sh'.
anSFS2 := StandardFileStream newFileNamed: aFileName2.
anSFS2 nextPutAll:  '#!!/bin/sh', Character lf , ' ',  cmd2.

osp3 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName2).
(Delay forSeconds: 2) wait.
osp4 := ExternalUnixOSProcess exec: aFileName2.
(Delay forSeconds: 3) wait.

aFileName3 := '/Volumes/MediaVault/BBC/test3.sh'.
anSFS3 := StandardFileStream newFileNamed: aFileName3.

anSFS3 nextPutAll:  '#!!/bin/sh', Character lf, 
'rm /Volumes/MediaVault/BBC/' , fileName , '  ; rm /Volumes/MediaVault/BBC/test.sh; rm /Volumes/MediaVault/BBC/test2.sh ; rm /Volumes/MediaVault/BBC/test3.sh '.
osp5 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName3).
(Delay forSeconds: 1) wait.
osp6 := ExternalUnixOSProcess exec: aFileName3.
^ self! !

!BBCEpisodeRecorder class methodsFor: 'accessing' stamp: 'jrm 1/31/2015 13:49'!
record: aBBCEpisode

"BBCEpisodeRecorder record: (BBCEpisode new)"

	

! !

!BBCEpisodeRecorder class methodsFor: 'accessing' stamp: 'jrm 2/2/2015 21:29'!
recordEpisode: aBBCEpisode

"BBCEpisodeRecorder record: (BBCEpisode new)"

	self new recordEpisode: aBBCEpisode.

	

! !

!BBCEpisodeRecorder class methodsFor: 'accessing' stamp: 'jrm 2/6/2015 16:23'!
recordPid: episodePid
	"Record from an episode pid. Skip using an iplayer or schedule object. Good for testing and one off requests"

	|  |

	"BBCEpisodeRecorder recordPid: episodePid"
	self new recordPid: episodePid.! !

!BBCEpisodeRecorder class methodsFor: 'sandbox' stamp: 'jrm 9/19/2014 07:12'!
sandbox1
	"tempory method to help me figure out the code I need."
"self sandbox1"
| aFileName anSFS osp1 osp2 osp3 |
aFileName := '/Volumes/MediaVault/BBC/test.sh'.
anSFS := StandardFileStream newFileNamed: aFileName.
anSFS nextPutAll:  '#!!/bin/sh', Character lf,
'/opt/local/bin/rtmpdump -r "rtmp://bbcodspdns.fcod.llnwd.net:1935/a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p0267tbs_b04gr529_1410775752358.mp4&et=1411143145&fmta-token=6ffbf79bdcc0f21fb37414c9e9d29c9d89b92c806bb91dd455ca1cc642196717" -a "a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p0267tbs_b04gr529_1410775752358.mp4&et=1411143145&fmta-token=6ffbf79bdcc0f21fb37414c9e9d29c9d89b92c806bb91dd455ca1cc642196717" -y "mp4:prod_rb2_flv_aac_low_intl/iplayerstream/p0267tbs_b04gr529_1410775752358.mp4" -o /Volumes/MediaVault/BBC/693645057.flv ; ffmpeg -loglevel quiet  -i /Volumes/MediaVault/BBC/693645057.flv -c copy -copyts /Volumes/MediaVault/BBC/QueensofNoise-RipItUp.1.5.mp4 ; rm /Volumes/MediaVault/BBC/693645057.flv'.
anSFS close.

osp1 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName).
osp2 := ExternalUnixOSProcess exec: aFileName.
self halt.
"osp2 := ExternalOSProcess exec: aFileName."
"osp3 := OSProcess  waitForCommand: 'rm ', aFileName."
^ self! !

!BBCEpisodeRecorder class methodsFor: 'sandbox' stamp: 'jrm 9/20/2014 22:01'!
sandbox2
	"tempory method to help me figure out the code I need. 9/18/2014 this works with the halts in place!!"
"self sandbox2"
| aFileName anSFS  aFileName2 anSFS2 osp1 osp2 osp3 osp4 aFileName3 anSFS3 osp5 osp6 |
aFileName := '/Volumes/MediaVault/BBC/test.sh'.
anSFS := StandardFileStream newFileNamed: aFileName.
anSFS nextPutAll:  '#!!/bin/sh', Character lf,
'/opt/local/bin/rtmpdump -r "rtmp://bbcodspdns.fcod.llnwd.net:1935/a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p0267wk4_b01mqm8w_1410789282188.mp4&et=1411282771&fmta-token=875ad8e998f9f18116e050d81ec4ab579e2c3cb174c19b06fbbe55550d542fd7" -a "a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p0267wk4_b01mqm8w_1410789282188.mp4&et=1411282771&fmta-token=875ad8e998f9f18116e050d81ec4ab579e2c3cb174c19b06fbbe55550d542fd7" -y "mp4:prod_rb2_flv_aac_low_intl/iplayerstream/p0267wk4_b01mqm8w_1410789282188.mp4" -o /Volumes/MediaVault/BBC/1059351257.flv'.
anSFS close.

osp1 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName).
osp2 := ExternalUnixOSProcess command: aFileName.
self halt.
aFileName2 := '/Volumes/MediaVault/BBC/test2.sh'.
anSFS2 := StandardFileStream newFileNamed: aFileName2.
anSFS2 nextPutAll:  '#!!/bin/sh', Character lf,
' ffmpeg -loglevel quiet  -i /Volumes/MediaVault/BBC/1059351257.flv -c copy -copyts /Volumes/MediaVault/BBC/jjunk.mp4'.
osp3 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName2).
self halt.
osp4 := ExternalUnixOSProcess forkAndExec: aFileName2.

aFileName3 := '/Volumes/MediaVault/BBC/test3.sh'.
anSFS3 := StandardFileStream newFileNamed: aFileName3.
anSFS3 nextPutAll:  '#!!/bin/sh', Character lf,
'rm /Volumes/MediaVault/BBC/243594461.flv; rm /Volumes/MediaVault/BBC/test.sh; rm /Volumes/MediaVault/BBC/test2.sh ; rm /Volumes/MediaVault/BBC/test3.sh rm /Volumes/MediaVault/BBC/1059351257.flv ' .
osp5 := ExternalUnixOSProcess command:  ('chmod  u+x ' , aFileName3).
self halt.
osp6 := ExternalUnixOSProcess forkAndExec: aFileName3.
self halt.
^ self! !

!BBCEpisodeRecorder class methodsFor: 'sandbox' stamp: 'jrm 9/20/2014 21:27'!
sandbox3
	"Trying the suggestions from newbies mail list."
"self sandbox3"
|  cmd1 cmd2 posps1 posps2 result |
cmd1 := '/opt/local/bin/rtmpdump -r "rtmp://bbcodspdns.fcod.llnwd.net:1935/a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p026ftq0_b01mqpqv_1411048434816.mp4&et=1411107013&fmta-token=f3e2aeb0616af3237be383ae5571826d1b0a5866b89dbff066471398d3883fbe" -a "a5999/e1?as=adobe-hmac-sha256&av=1&te=connect&mp=prod_rb2_flv_aac_low_intl/iplayerstream/p026ftq0_b01mqpqv_1411048434816.mp4&et=1411107013&fmta-token=f3e2aeb0616af3237be383ae5571826d1b0a5866b89dbff066471398d3883fbe" -y "mp4:prod_rb2_flv_aac_low_intl/iplayerstream/p026ftq0_b01mqpqv_1411048434816.mp4" -o /Volumes/MediaVault/BBC/197674426.flv'.

posps1 := PipeableOSProcess shell.
posps1 pipeFromOutput setNonBlocking.
posps1 exec: cmd1.
posps1 close.
	(Delay forSeconds: 15) wait.
result := posps1 upToEndOfFile.
self halt.
cmd2 :='; ffmpeg -loglevel quiet  -i /Volumes/MediaVault/BBC/197674426.flv -c copy -copyts /Volumes/MediaVault/BBC/junk.mp4'.

posps2 := PipeableOSProcess shell.
posps2 pipeFromOutput setNonBlocking.
posps2 exec: cmd2.
self halt.
^ self! !

!BBCEpisodeRecorder methodsFor: 'as yet unclassified' stamp: 'jrm 2/2/2015 21:29'!
recordEpisode: aBBCEpisode

self halt.! !

!BBCEpisodeRecorder methodsFor: 'as yet unclassified' stamp: 'jrm 2/6/2015 16:59'!
recordPid: episodePid

	|  |

	BBCEpisode newFromEpisode: episodePid.

 self halt.! !

Object subclass: #BBCOutlet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCOutlet commentStamp: 'jrm 3/1/2014 12:52' prior: 0!
A BBCOutlet is required to manage a variety of address patterns used by different BBC outlets. Radio 1 and Radio 4 seem to be the problem children.

http://www.bbc.co.uk/radio1/programmes/schedules/england/today.xml
http://www.bbc.co.uk/1xtra/programmes/schedules/today.xml
http://www.bbc.co.uk/radio2/programmes/schedules/today.xml
http://www.bbc.co.uk/radio3/programmes/schedules/today.xml
http://www.bbc.co.uk/radio4/programmes/schedules/lw/today.xml
http://www.bbc.co.uk/radio4/programmes/schedules/fm/today.xml
http://www.bbc.co.uk/radio4extra/programmes/schedules/today.xml
http://www.bbc.co.uk/5live/programmes/schedules/today
http://www.bbc.co.uk/5livesportsextra/programmes/schedules.xml
http://www.bbc.co.uk/6music/programmes/schedules.xml
http://www.bbc.co.uk/worldserviceradio/programmes/schedules/today.xml

hmmm... new information

http://www.bbc.co.uk/radio4extra/programmes/schedules/this_week.xml
http://www.bbc.co.uk/radio4extra/programmes/schedules/last_week.xml


Instance Variables
!

Object subclass: #BBCRadioAvailability
	instanceVariableNames: 'outlet startDtime endDtime episodes'
	classVariableNames: 'OutletUrlStub'
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCRadioAvailability commentStamp: 'jrm 1/19/2015 19:29' prior: 0!
A BBCRadioAvailabilitySchedule is the collection of broadcasts which are currently (at the time the object in instantiated) available for listening. The BBC Calls this Listen Again. Most/all programs are supposed to be available for seven(30 now? jrm 20150119) days following the datetime of broadcast. Since a specific program can be re-broadcast within a few days or hours of each other, we must chose the latest broadcast date in the collection to create a single instance for that show. BBC provides weekly schedules by outlet.

Availability is also provided by genra for Iplayer. Schedule availability is limited to schedule entries, but there are programs available in Iplayer that are not on the current schedules

This class will allow availability to be designated by an availabilityMode of #schedule or genra.

Class Variables

OutletUrlStub
	- A Dictionary mapping outlet names to the schedule url stub for the outlet. We do this because there is a url for 'this_week' and 'last_week' with a variety of stubs.

Instance Variables

broadcasts
	- An OrderedCollection of broadcast objects which contain all of the information required to generate a command line string to be executed by the OS. (Sqeak cannot currently record audio streams.

endDtime
	- The datetime, in Z, of the end of the schdule coverage period. Determined by the latest availability date for any broadcast in the collection
	
startDtime
	- The datetime, in Z, of the start of the schdule coverage period. Determined by the earliest availability date for any broadcast in the collection
	
outlet
	- The BBC Radio station identifier for the schedule.

outlet, start and endDtime are derived from the content of broadcasts.
!

!BBCRadioAvailability class methodsFor: 'class initialization' stamp: 'jrm 3/1/2014 13:09'!
initialize
	"BBCRadioAvailabilitySchedule initialize" 
	super initialize.
	OutletUrlStub := (Dictionary new).
	OutletUrlStub
		at: 'radio4extra' put: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/';
		at: 'radio3' put: 'http://www.bbc.co.uk/radio3/programmes/schedules/';
		at: 'radio4' put: 'http://www.bbc.co.uk/radio4/programmes/schedules/fm/';
		at: 'radio2' put: 'http://www.bbc.co.uk/radio2/programmes/schedules/';
		at: '6music' put: 'http://www.bbc.co.uk/6music/programmes/schedules/';
		at: 'radio1' put: 'http://www.bbc.co.uk/radio1/programmes/schedules/england/';
		at: '1xtra' put: 'http://www.bbc.co.uk/1xtra/programmes/schedules/';
		yourself



	
! !

!BBCRadioAvailability class methodsFor: 'instance creation' stamp: 'jrm 3/1/2014 12:58'!
newFor: anOutlet
	"There is no one standard pattern for an outlet, so we build the appropriate urlStub here and create a new instance that will populate itself using the stub."

	"BBCRadioAvailabilitySchedule newFor: 'radio4extra' "

	|  newSchedule|
	newSchedule := self new.
	anOutlet = nil ifFalse:[
	^ newSchedule newFrom:  (OutletUrlStub at: anOutlet)]


	
! !

!BBCRadioAvailability class methodsFor: 'instance creation' stamp: 'jrm 3/1/2014 12:44'!
newFrom: aUrl
	"Build a schedule of all currently available programs. The tag, <is_available_mediaset_pc_sd>0</is_available_mediaset_pc_sd> indicates that the broadcasts is not available >1< means it is. Get data from 'this_week' and 'last_week'"

	"BBCRadioAvailabilitySchedule newFrom: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/this_week.xml' "

	|  newSchedule |

	newSchedule := self new.
	
	^ newSchedule newFrom: aUrl


	
! !

!BBCRadioAvailability class methodsFor: 'instance creation' stamp: 'jrm 1/17/2015 21:34'!
newFromGenra: aCategoryString
	"Build a schedule of all currently available iplayer programs in the given category"

	"BBCRadioAvailabilitySchedule newFromGenra: 'drama/crime'"

	|  newSchedule |

	newSchedule := self new.
	
	^ newSchedule newFromGenra: aCategoryString


	
! !

!BBCRadioAvailability class methodsFor: 'instance creation' stamp: 'jrm 1/31/2015 13:52'!
newFromSchedule: aUrl
	"Build a schedule of all currently available programs. The tag, <is_available_mediaset_pc_sd>0</is_available_mediaset_pc_sd> indicates that the broadcasts is not available >1< means it is. Get data from 'this_week' and 'last_week'"

	"BBCRadioAvailability newFromSchedule: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/this_week.xml' "

	|  newSchedule |

	newSchedule := self new.
	
	^ newSchedule newFromSchedule: aUrl


	
! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 14:40'!
compressSchedule
	"Compress the schedule by removing multiple broadcast entries for a single title (shows
	are broadcast more than once)"
	
	| aDictionary temp anOrderedCollection |
	
	aDictionary := Dictionary new.
	temp := episodes collect: [:each | aDictionary at: each title put: each].
	anOrderedCollection := OrderedCollection new.
	aDictionary valuesDo: [ :each | anOrderedCollection add: each].
	episodes := anOrderedCollection.
	! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 14:41'!
episodes

	
		^ episodes
	! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 14:41'!
episodes: anOrderedCollection

	
		^ episodes := anOrderedCollection
	! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/25/2015 14:40'!
newFrom: aUrlStub
	"Build a schedule of all currently available programs. The tag, <is_available_mediaset_pc_sd>0</is_available_mediaset_pc_sd> indicates that the broadcasts is not available >1< means it is. Get data from 'this_week' and 'last_week' using aUrlStub"

	"BBCRadioAvailabilitySchedule newFrom: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/'' "

	|  xmlStream anXMLDocument root |

	episodes := OrderedCollection new.
	"Get 'this_week'"
	{ 'this_week' . 'last_week'} do: [:each | 
	
	xmlStream := HTTPClient httpGet: aUrlStub, each, '.xml'.
	anXMLDocument  := XMLDOMParser parseDocumentFrom: (xmlStream).
	root := anXMLDocument root.
	root tagsNamed: #'day' childrenDo: [:every | every tagsNamed: #'broadcast' do: [:one | 
			
	episodes add: (BBCRadioBroadcast newFrom: one) ]]].
	episodes removeAllSuchThat: [:each | each == nil].
	self compressSchedule.
	episodes sort: [:a :b | a title  > b title].


	
! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/29/2015 07:04'!
newFromGenra: aGenraString
	"aGenraString is used to build the url for an Available Now xml element"

	"http://http://www.bbc.co.uk/radio/programmes/genres/drama/actionandadventure/player/episodes.xml?all"

"BBCRadioAvailability newFromGenra: 'drama/scifiandfantasy'"

	|  xmlStream anXMLDocument root episodesUrl |

	episodes := OrderedCollection new.
	episodesUrl := 'http://www.bbc.co.uk/radio/programmes/genres/', aGenraString, '/player/episodes.xml?all'.
	xmlStream := HTTPClient httpGet: episodesUrl.

	anXMLDocument  := XMLDOMParser parseDocumentFrom: (xmlStream).
	root := anXMLDocument root.
	root tagsNamed: #'day' childrenDo: [:every | every tagsNamed: #'broadcast' do: [:one | 		
	episodes add: (self newFrom: one)]].


	^ episodes sort: [:a :b | a title  > b title].! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 2/6/2015 17:13'!
newFromPid: episodePid
	"aGenraString is used to build the url for an Available Now xml element"

	"http://http://www.bbc.co.uk/radio/programmes/genres/drama/actionandadventure/player/episodes.xml?all"

"BBCRadioAvailability newFromGenra: 'drama/scifiandfantasy'"

	|  xmlStream anXMLDocument root episodesUrl |

self halt.
"
	episode := .
	episodesUrl := 'http://www.bbc.co.uk/radio/programmes/genres/', aGenraString, '/player/episodes.xml?all'.
	xmlStream := HTTPClient httpGet: episodesUrl.

	anXMLDocument  := XMLDOMParser parseDocumentFrom: (xmlStream).
	root := anXMLDocument root.
	root tagsNamed: #'day' childrenDo: [:every | every tagsNamed: #'broadcast' do: [:one | 		
	episodes add: (self newFrom: one)]].


	^ episodes sort: [:a :b | a title  > b title]."! !

!BBCRadioAvailability methodsFor: 'as yet unclassified' stamp: 'jrm 1/31/2015 13:55'!
newFromSchedule: aUrlStub
	"Build a schedule of all currently available programs. The tag, <is_available_mediaset_pc_sd>0</is_available_mediaset_pc_sd> indicates that the broadcasts is not available >1< means it is. Get data from 'this_week' and 'last_week' using aUrlStub"

	"BBCRadioAvailability newFrom: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/' "

	|  xmlStream anXMLDocument root |

	episodes := OrderedCollection new.
	"Get 'this_week'"
	{ 'this_week' . 'last_week'} do: [:each | 
	
	xmlStream := HTTPClient httpGet: aUrlStub, each, '.xml'.
	anXMLDocument  := XMLDOMParser parseDocumentFrom: (xmlStream).
	root := anXMLDocument root.
	root tagsNamed: #'day' childrenDo: [:every | every tagsNamed: #'broadcast' do: [:one | 
			
	episodes add: (BBCRadioBroadcast newFrom: one) ]]].
	episodes removeAllSuchThat: [:each | each == nil].
	self compressSchedule.
	episodes sort: [:a :b | a title  > b title].


	
! !

Object subclass: #BBCRadioBroadcast
	instanceVariableNames: 'duration episodePid episodePosition episodeTitle episodeSynopsis seriesTitle seriesPosition seriesChildCount brandTitle brandPosition brandChildCount outlet availableStartTime availableEndTime availabilityComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCRadioBroadcast class methodsFor: 'as yet unclassified' stamp: 'jrm 2/18/2014 18:51'!
newFrom: anXMLElement
	"comment stating purpose of message"

	| broadcast |
	
	broadcast := self new.
	(anXMLElement firstTagNamed: #'available_until') == nil 
	ifFalse: [broadcast populateFrom: anXMLElement.
	^ broadcast]
		ifTrue: [^ nil]
			

! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/18/2014 20:06'!
availabilityLimit

	| aStream available |
	
	aStream := (WriteStream on: (String new: 16)).
	available := availableEndTime.
	 available == nil 
	ifFalse: [available printYMDOn: aStream] ifTrue: [aStream := '0000-00-00'].
	^aStream contents! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 12/14/2015 19:15'!
availabilityStart

	| aStream availableStart |
	
	aStream := (WriteStream on: (String new: 16)).
	availableStart := availableStartTime.
	 availableStart == nil 
	ifFalse: [availableStart printYMDOn: aStream] ifTrue: [aStream := '0000-00-00'].
	^aStream contents! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/8/2014 15:58'!
availableUntil

	"aDate"
	^ self programme availableUntil! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 1/31/2015 15:11'!
buildCommandLineString


	|destinationFilePath episodeUrl  anXMLDocument mediaPid fileName cmdLine |
	destinationFilePath := '/Volumes/MediaVault/BBC/'.
	episodeUrl := 'http://www.bbc.co.uk/programmes/', episodePid, '.xml'.
	anXMLDocument  := XMLDOMParser
				parseDocumentFrom: (HTTPClient httpGet: episodeUrl).
	mediaPid := (( anXMLDocument root firstTagNamed: #version) firstTagNamed: #pid ) contentString.
fileName := self composeFileName. 
cmdLine := BBCRadioMediaSelector  buildMediaSelectorString: episodePid fileName: fileName , '.mp4'.! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 9/9/2014 19:14'!
composeFileName

	"build a reasonable string to be used as a filename in a command "
	| fileName option tempFileName |
	fileName := self titleForFileName.
	tempFileName := ByteString new.
	fileName := fileName select: [ :each | each value ~= Character space].
	fileName := fileName select: [ :each | each value ~= (Character characterTable at: 64)].
	fileName do: [:each | each = $/ ifTrue: [each := '-'].
						   each = $: ifTrue: [each := '-'].
					         each = $' ifTrue: [each := '-' ]].
	"tempFileName := SequenceableCollection streamContents: [fileName]."
	fileName  replaceAll:  $/  with: $-. 
	fileName replaceAll:  $:  with: $-.
	fileName replaceAll:  $'  with: $-.
	fileName replaceAll:  $, with: $-.
	"Ask for the desired option"
	option := UserDialogBoxMorph confirm: 'File Name for Stream' withCRs title: 'Create new, or look up existing?' trueChoice: 'Lookup' falseChoice: 'Create'.  
	option ifTrue: [ fileName := self fileNameFromString: (self fileNameFromDirectory: fileName )] 
			ifFalse:[fileName := self fileNameFromString: fileName].	
	^ fileName   " move the suffix attachement to another place     , '.mp3'"! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/3/2014 19:33'!
duration: aString


	duration := aString asInteger! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/7/2014 21:24'!
endTime


	^endTime! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/3/2014 19:09'!
endTime: aDate


	endTime := aDate! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/18/2014 22:01'!
episodePid

	^ episodePid
	
! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/16/2014 20:46'!
episodePid: aString

	episodePid := aString
	
! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/22/2014 22:12'!
fileNameFromDirectory: aString
	" Let me select a name from a list so I can keep the file names for a list similar. I will edit the file 	name that I select in a later step"
	"BBCRecorderApp fileNameFromList"
	
	| fileList fileNameLIst fileName|
	fileList := (FileList newOn: (FileDirectory on: '/Volumes/MediaVault/BBC')) entriesMatching: '*.mp3'.
	fileNameLIst := fileList collect: [ :each | each name].
	fileName := ListChooser chooseItemFrom: fileNameLIst title: 'Hint: ', aString.
	"Strip file type indicator string .mp3 from end of file"
	^ fileName == nil ifTrue: [^fileName] ifFalse: [^ fileName copyFrom: 1 to: (fileName size -4)]
! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/22/2014 21:50'!
fileNameFromString: aString
	"Modify the title string to create a useful file name to store the transcribed stream."
	
	
	^ FillInTheBlankMorph  request:  '.MP3 will be appended to file name' initialAnswer: aString centerAt: 500@500.! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/10/2014 21:39'!
mediaUrl


	^ programme mediaUrl! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/18/2014 23:00'!
populateFrom: anXMLNode

	| episodeProgram seriesProgram brandProgram |
	
	((anXMLNode firstTagNamed: #'available_until')  == nil) ifTrue: [ ^ nil ].
	
	duration := (anXMLNode firstTagNamed: #duration) contentString asInteger.
	availableStartTime := (anXMLNode firstTagNamed: #'actual_start') contentString asDateAndTime.
		availableEndTime := (anXMLNode firstTagNamed: #'available_until') contentString asDateAndTime.
		availabilityComment:= (anXMLNode firstTagNamed: #availability) contentString.
	
	episodeProgram := (anXMLNode firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'episode'] ).
	episodePid := (episodeProgram firstTagNamed: #pid) contentString.
	episodePosition := (episodeProgram firstTagNamed: #position) contentString.
	episodeTitle := (episodeProgram firstTagNamed: #title) contentString.
	 episodeSynopsis := (episodeProgram firstTagNamed: #'short_synopsis') contentString.
	
	seriesProgram := (anXMLNode firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'series'] ).
	seriesProgram == nil ifFalse: [
		seriesTitle := (seriesProgram firstTagNamed: #title) contentString.
		seriesPosition := (seriesProgram firstTagNamed: #position) contentString.
		seriesChildCount := (seriesProgram firstTagNamed: #'expected_child_count') contentString].		
		
	brandProgram := (anXMLNode firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'brand'] ).
	brandProgram == nil ifFalse: [
		brandTitle := (brandProgram firstTagNamed: #title) contentString.
		brandPosition := (brandProgram) contentString.
		brandChildCount := (brandProgram firstTagNamed: #'expected_child_count') contentString.	
		outlet := ((brandProgram firstTagNamed: #ownership) firstTagNamed: #service) attributeAt: 'key'].
	
	seriesTitle == nil ifTrue: [seriesTitle := ''].
	seriesPosition == nil ifTrue: [seriesPosition := ''].
	seriesChildCount == nil ifTrue: [seriesChildCount := ''].
	brandTitle == nil ifTrue: [brandTitle := ''].
	brandPosition == nil ifTrue: [brandPosition := ''].
	brandChildCount == nil ifTrue: [brandChildCount := ''].
	






! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/7/2014 22:23'!
programme

	^ programme! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 3/1/2014 12:42'!
programme: anXMLNode

	| programmeSeries programmeBrand available episodeProgram programme |
	programme := BBCRadioProgramme new.
	
	episodeProgram := (anXMLNode firstTagNamed: #programme with: [:target | (target attributes at: 'type') = 'episode'] ).
	episodePid := episodeProgram firstTagNamed: #pid.
	episodePosition := episodeProgram firstTagNamed: #position.
	episodeTitle := episodeProgram firstTagNamed: #title.
	 episodeSynopsis := episodeProgram firstTagNamed: #'short_synopsis'.
	
		"  This is a call to another web page. We do not need it now. Get it when it is needed
			mediaUrl: programmePid;"
			programme episodePid: episodePid; 

				 programmePosition: (anXMLNode firstTagNamed: #position) contentString;
				 programmeTitle: (anXMLNode firstTagNamed: #title) contentString;
				 synopsis: (anXMLNode firstTagNamed: #'short_synopsis') contentString.

				" #'available_until' is not present if the program is not currently available"
				available := anXMLNode firstTagNamed: #'available_until'.
				available   == nil   ifFalse: [programme availableUntil: (DateAndTime fromString:( available contentString)) ].
				 programmeSeries := (anXMLNode firstTagNamed: #programme with:[:each | (each valueFor: #type) = 'series']).
				 programmeBrand := (anXMLNode firstTagNamed: #programme with:[:each | (each valueFor: #type) = 'brand']).
				
				" have to deal with brands or series!! No consistancy in the XML files"  
	programmeSeries = nil ifFalse: [
	programme seriesTitle: (programmeSeries firstTagNamed: #title) contentString;
				 childCount: (programmeSeries firstTagNamed: #'expected_child_count') contentString;
				 seriesPosition: (programmeSeries firstTagNamed: #position) contentString].
	programmeBrand = nil ifFalse: [
	programme brandTitle: (programmeBrand firstTagNamed: #title)contentString].
self halt.
	^ programme! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/10/2014 21:33'!
programmePid

	^ programme programmePid! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 12/9/2014 07:08'!
scheduleMorph
	"create a single StringMorph for a single schedule entry."

	| tMorph t1 t2 t3 |	
		tMorph := StringButtonMorph new.
	t1 := (self title, '  ').
	t2 := self availabilityLimit.
	t3 := (episodeSynopsis).
	
	^tMorph contents: (t2, ' ', t1); setBalloonText: t3; balloonColor: (Color yellow); balloonFont: (StrikeFont familyName: 'Helvetica' size: 14).! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/3/2014 19:09'!
startTime: aDate


	startTime := aDate! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 2/23/2014 15:18'!
title

	"seriesPosition   brandPosition brandChildCount "
	
	| displayNofM displayBrandTitle displaySeriesTitle displayEpisodeTitle |
	
	episodePosition = '' ifTrue: [ displayNofM := ''] ifFalse: [ displayNofM := ' ', episodePosition, '.', seriesChildCount, ' '].
	seriesPosition = '' ifFalse: [displayNofM := ' ', seriesPosition, '.', episodePosition, '.', seriesChildCount, ' '].
	( 'Episode*' match: episodeTitle ) ifTrue: [displayEpisodeTitle := ''] ifFalse: [displayEpisodeTitle := episodeTitle].
	('Series*'  match: seriesTitle) ifTrue: [displaySeriesTitle := ''] ifFalse: [displaySeriesTitle := seriesTitle].
	brandTitle = '' ifFalse: [displayBrandTitle := brandTitle, ' '] ifTrue: [displayBrandTitle := ''].
	
	^ displayBrandTitle,displaySeriesTitle, displayNofM, displayEpisodeTitle
	
	! !

!BBCRadioBroadcast methodsFor: 'as yet unclassified' stamp: 'jrm 8/17/2014 12:46'!
titleForFileName

	"seriesPosition   brandPosition brandChildCount "
	
	| displayNofM displayBrandTitle displaySeriesTitle displayEpisodeTitle episodeDashCheck dotSeriesChildCount |

	seriesChildCount ~= '' ifTrue: [dotSeriesChildCount := '.',seriesChildCount] ifFalse: [dotSeriesChildCount :=''].
	episodePosition = '' ifTrue: [ displayNofM := ''] 
						ifFalse: [ displayNofM := '.', episodePosition, dotSeriesChildCount].
	seriesPosition = '' ifFalse: [displayNofM := '.', seriesPosition, '.', episodePosition, '.', seriesChildCount].
	( 'Episode*' match: episodeTitle ) ifTrue: [displayEpisodeTitle := ''] ifFalse: [displayEpisodeTitle := episodeTitle].
	('Series*'  match: seriesTitle) ifTrue: [displaySeriesTitle := ''] ifFalse: [displaySeriesTitle := seriesTitle].
	brandTitle = '' ifFalse: [displayBrandTitle := brandTitle] ifTrue: [displayBrandTitle := ''].
	episodeDashCheck := displayBrandTitle,displaySeriesTitle, displayNofM.
	(episodeDashCheck ~= '' ) & (displayEpisodeTitle ~= '')  ifTrue: [displayEpisodeTitle := '-', displayEpisodeTitle].
	^ displayBrandTitle,displaySeriesTitle, displayNofM, displayEpisodeTitle
	
	! !

Object subclass: #BBCRadioMediaSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCRadioMediaSelector class methodsFor: 'experiments' stamp: 'jrm 9/28/2014 13:46'!
buildMediaSelectorScript: anEpisodePid fileName: fileName

" command line for RTMPDUMP" 

"Build a shell script file and return the filename to be executed in an OSProcess exec:"

	"A anEpisodepid is an identifier that can be used to create a uri which can be used to obtain an XML file which contains the mms address to a recordable stream. There are different kinds of pidsThe most reliable way to get a selector string is to parse from the mtis version e.g. http://www.bbc.co.uk/mediaselector/4/mtis/stream/<pid> 
 " 
	| scriptFilename episodeUrl episodeDocument mediaAac connection  kind supplier application authExpires authString identifier priority protocol server flvFileName mp4Filename canonicalPid mediaDocument episodeStream mediaStream defaultDestination cmdLine1 randomString cmdLine2 cmdLine3 dQuote  |
	defaultDestination := BBCRecorderApp defaultDestination.
	dQuote := '"'.

	episodeUrl := 'http://www.bbc.co.uk/programmes/', anEpisodePid, '.xml'.

"'http://www.bbc.co.uk/mediaselector/4/mtis/stream/'"

	episodeStream :=HTTPClient httpGet: episodeUrl.	
	episodeDocument  := XMLDOMParser parseDocumentFrom: (episodeStream).
	canonicalPid := ((episodeDocument firstTagNamed: #versions) firstTagNamed: #pid )contentString.
	mediaStream:= HTTPClient httpGet: 'http://www.bbc.co.uk/mediaselector/4/mtis/stream/', canonicalPid.
	mediaDocument := XMLDOMParser parseDocumentFrom: (mediaStream).
	mediaAac := mediaDocument firstTagNamed: #media with: [:each | (each attributeAt: #encoding) = 'aac'].
 	connection := (mediaAac firstTagNamed: #connection) attributes.


kind := connection at: #kind.
supplier  := connection at: #supplier.
protocol  := connection at: #protocol.
authExpires   := connection at: #authExpires.
authString  := connection at: #authString.
priority  := connection at: #priority.
server  := connection at: #server.
application  := connection at: #application.
identifier  := connection at: #identifier.
randomString := Random new seed asString.
flvFileName := randomString, '.flv'.
mp4Filename := fileName, '.mp4'.
cmdLine1 := '/opt/local/bin/rtmpdump -r ' , dQuote, protocol, '://', server, ':1935/',  application, '?', authString, dQuote, ' -a ', dQuote, application, '?', authString, dQuote, ' -y "', identifier, dQuote,  ' -o ', defaultDestination, flvFileName.
cmdLine2 := '/opt/local/bin/ffmpeg -loglevel quiet  -i ', defaultDestination, flvFileName, ' -c copy -copyts ', defaultDestination, mp4Filename.
cmdLine3 := 'rm ', defaultDestination, flvFileName, '> temp.junk'.
"I am not sure what should be returned here, probably not an array, but this will do for now"
^ {cmdLine1. cmdLine2. cmdLine3. flvFileName}! !

!BBCRadioMediaSelector class methodsFor: 'experiments' stamp: 'jrm 2/7/2014 19:38'!
buildMediaSelectorString:aPid
	"A pid is a program identifier that can be used to create a uri which can be used to obtain an XML file which contains the mms address to a recordable stream. The iplayer uri is part of the stream from the mtis version. You can use it, but there is more extraneous data to work with. http://www.bbc.co.uk/mediaselector/4/mtis/stream/<pid> They both can be generated by inserting a pid. I am using the iplayer version, not the mtis one. http://www.bbc.co.uk/mediaselector/4/asx/b007qtjp/iplayer_intl_stream_wma_lo_concrete  "

	| episodeUrl episode anXMLDocument canonical mediaUrl |

	episodeUrl := 'http://www.bbc.co.uk/programmes/', aPid, '.xml'.

episode :=HTTPClient httpGet: episodeUrl.		
	anXMLDocument  := XMLDOMParser parseDocumentFrom: (episode).
	canonical := ((anXMLDocument firstTagNamed: #versions) firstTagNamed: #pid )contentString.
	^ mediaUrl := 'http://www.bbc.co.uk/mediaselector/4/asx/', canonical , '/iplayer_intl_stream_wma_lo_concrete' .
! !

!BBCRadioMediaSelector class methodsFor: 'accessing' stamp: 'jrm 12/14/2015 19:41'!
buildMediaSelectorString: anEpisodePid fileName: fileName

" command line for RTMPDUMP; ffmpeg, and rm" 

"This is a variation that creates a shell command file and writes it to the default file path and then executes the shell file using OSProcess. I could not figure out how to get the string to execute in OSProcess because it seems to eat ampersands & rather than pass them through as part of the command"

	"A anEpisodepid is an identifier that can be used to create a uri which can be used to obtain an XML file which contains the mms address to a recordable stream. There are different kinds of pidsThe most reliable way to get a selector string is to use the data from the mediaselector e.g. http://open.live.bbc.co.uk/mediaselector/5/select/version/2.0/mediaset/pc/<pid> 
 " 
	| mediaAac mediaDocument anSFS cmdLine dQuote episodeUrl episodeDocument  connection  supplier application authExpires authString identifier priority protocol server flvFileName mp4Filename canonicalPid  episodeStream mediaStream defaultDestination randomString osp1 osp2 osp3 |
	defaultDestination := BBCRecorderApp defaultDestination.
	randomString := (((Random new next ) * 100000000) asInteger) asString.
	dQuote := '"'.

	episodeUrl := 'http://www.bbc.co.uk/programmes/', anEpisodePid, '.xml'.


	episodeStream :=HTTPClient httpGet: episodeUrl.	
	episodeDocument  := XMLDOMParser parseDocumentFrom: (episodeStream).
	canonicalPid := ((episodeDocument firstTagNamed: #versions) firstTagNamed: #pid )contentString.
	"mediaStream:= HTTPClient httpGet: 'http://www.bbc.co.uk/mediaselector/4/mtis/stream/', canonicalPid.  >>> depreciated url prefix"
	mediaStream:= HTTPClient httpGet: 'http://open.live.bbc.co.uk/mediaselector/5/select/version/2.0/mediaset/pc/vpid/', canonicalPid.
	mediaDocument := XMLDOMParser parseDocumentFrom: (mediaStream).
	mediaAac := mediaDocument
				firstTagNamed: #media
				with: [:each | (each attributeAt: #service)
						= 'stream-nonuk-audio_streaming_aac_vlow'].
 	connection := (mediaAac firstTagNamed: #connection) attributes.

supplier  := connection at: #supplier.
protocol  := connection at: #protocol.
authExpires   := connection at: #authExpires.
authString  := connection at: #authString.
priority  := connection at: #priority.
server  := connection at: #server.
application  := connection at: #application.
identifier  := connection at: #identifier.
flvFileName := randomString, '.flv'.
mp4Filename := fileName.
cmdLine := '/opt/local/bin/rtmpdump -r ' , dQuote, protocol, '://', server, ':1935/',  application, '?', authString, dQuote, ' -a ', dQuote, application, '?', authString, dQuote, ' -y "', identifier, dQuote,  ' -o ', defaultDestination, flvFileName, ' ; /opt/local/bin/ffmpeg -loglevel quiet  -i ', defaultDestination, flvFileName, ' -c copy -copyts ', defaultDestination, mp4Filename, ' ; rm ', defaultDestination, flvFileName.
"Create a shell command file, execute it, and delete it"
anSFS := StandardFileStream newFileNamed: defaultDestination, randomString, '.sh'.
anSFS nextPutAll:  '#!!/bin/sh', Character lf, ' ', cmdLine, Character lf.
anSFS close.

osp1 := ExternalUnixOSProcess command:  ('chmod  u+x ' , anSFS name).
(Delay forSeconds: 1) wait.
osp2 := ExternalUnixOSProcess exec: anSFS name.
osp3 := ExternalUnixOSProcess command:  ('rm ' , anSFS name).
^ anSFS! !

!BBCRadioMediaSelector class methodsFor: 'experiments' stamp: 'jrm 9/10/2014 21:54'!
buildMediaSelectorStringM:anEpisodePid

" command line for RTMPDUMP"
	"A anEpisodepid is an identifier that can be used to create a uri which can be used to obtain an XML file which contains the mms address to a recordable stream. There are different kinds of pidsThe most reliable way to get a selector string is to parse from the mtis version e.g. http://www.bbc.co.uk/mediaselector/4/mtis/stream/<pid> 
 " 
	| dQuote episodeUrl episodeDocument mediaAac connection  kind supplier application authExpires authString identifier priority protocol server cmdLine flvFileName mp4Filename canonicalPid mediaDocument episodeStream mediaStream defaultDestination |
	defaultDestination := BBCRecorderApp defaultDestination.
	dQuote := '"'.

	episodeUrl := 'http://www.bbc.co.uk/programmes/', anEpisodePid, '.xml'.

"'http://www.bbc.co.uk/mediaselector/4/mtis/stream/'"

	episodeStream :=HTTPClient httpGet: episodeUrl.	
	episodeDocument  := XMLDOMParser parseDocumentFrom: (episodeStream).
	canonicalPid := ((episodeDocument firstTagNamed: #versions) firstTagNamed: #pid )contentString.
	mediaStream:= HTTPClient httpGet: 'http://www.bbc.co.uk/mediaselector/4/mtis/stream/', canonicalPid.
	mediaDocument := XMLDOMParser parseDocumentFrom: (mediaStream).
	mediaAac := mediaDocument firstTagNamed: #media with: [:each | (each attributeAt: #encoding) = 'aac'].
 	connection := (mediaAac firstTagNamed: #connection) attributes.


kind := connection at: #kind.
supplier  := connection at: #supplier.
protocol  := connection at: #protocol.
authExpires   := connection at: #authExpires.
authString  := connection at: #authString.
priority  := connection at: #priority.
server  := connection at: #server.
application  := connection at: #application.
identifier  := connection at: #identifier.
flvFileName := Random new seed asString, '.flv'.
mp4Filename := 'rtmptesting.mp4'.
cmdLine := '/opt/local/bin/rtmpdump -r ' , dQuote, protocol, '://', server, ':1935/',  application, '?', authString, dQuote, ' -a ', dQuote, application, '?', authString, dQuote, ' -y "', identifier, dQuote,  ' -o ', defaultDestination, flvFileName, ' ; ffmpeg -loglevel quiet  -i ', defaultDestination, flvFileName, ' -c copy -copyts ', defaultDestination, mp4Filename , ' ; rm ', defaultDestination, flvFileName, '> temp.junk'
self halt.! !

!BBCRadioMediaSelector class methodsFor: 'experiments' stamp: 'jrm 9/21/2014 19:31'!
buildMediaSelectorStringM:anEpisodePid fileName: fileName

" command line for RTMPDUMP"
	"A anEpisodepid is an identifier that can be used to create a uri which can be used to obtain an XML file which contains the mms address to a recordable stream. There are different kinds of pidsThe most reliable way to get a selector string is to parse from the mtis version e.g. http://www.bbc.co.uk/mediaselector/4/mtis/stream/<pid> 
 " 
	| dQuote episodeUrl episodeDocument mediaAac connection  kind supplier application authExpires authString identifier priority protocol server cmdLine flvFileName mp4Filename canonicalPid mediaDocument episodeStream mediaStream defaultDestination |
	
	self halt.
	defaultDestination := BBCRecorderApp defaultDestination.
	dQuote := '"'.

	episodeUrl := 'http://www.bbc.co.uk/programmes/', anEpisodePid, '.xml'.

"'http://www.bbc.co.uk/mediaselector/4/mtis/stream/'"

	episodeStream :=HTTPClient httpGet: episodeUrl.	
	episodeDocument  := XMLDOMParser parseDocumentFrom: (episodeStream).
	canonicalPid := ((episodeDocument firstTagNamed: #versions) firstTagNamed: #pid )contentString.
	mediaStream:= HTTPClient httpGet: 'http://www.bbc.co.uk/mediaselector/4/mtis/stream/', canonicalPid.
	mediaDocument := XMLDOMParser parseDocumentFrom: (mediaStream).
	mediaAac := mediaDocument firstTagNamed: #media with: [:each | (each attributeAt: #encoding) = 'aac'].
 	connection := (mediaAac firstTagNamed: #connection) attributes.


	kind := connection at: #kind.
	supplier  := connection at: #supplier.
	protocol  := connection at: #protocol.
	authExpires   := connection at: #authExpires.
	authString  := connection at: #authString.
	priority  := connection at: #priority.
	server  := connection at: #server.
	application  := connection at: #application.
	identifier  := connection at: #identifier.
	flvFileName := Random new seed asString, '.flv'.
	mp4Filename := fileName.
	^ cmdLine := '/opt/local/bin/rtmpdump -r ' , dQuote, protocol, '://', server, ':1935/',  application, '?', authString, dQuote, ' -a ', dQuote, application, '?', authString, dQuote, ' -y "', identifier, dQuote,  ' -o ', defaultDestination, flvFileName, ' ; ffmpeg -loglevel quiet  -i ', defaultDestination, flvFileName, ' -c copy -copyts ', defaultDestination, mp4Filename , ' ; rm ', defaultDestination, flvFileName .
! !

!BBCRadioMediaSelector class methodsFor: 'experiments' stamp: 'jrm 3/1/2014 12:45'!
getHref: aPid
	" Href is a uri that   "

	| selector anXMLDocument root entry ref href |

	selector :=HTTPClient httpGet:   (BBCRadioMediaSelector buildMediaSelectorString: aPid).		
	anXMLDocument  := XMLDOMParser parseDocumentFrom: (selector).
	root := anXMLDocument root.
	entry := root firstTagNamed: #Entry.
	ref := entry firstTagNamed: #ref.
	href := ref attributeAt: #href.
	^ href := ref attributeAt: #href.
	
	! !

Object subclass: #BBCRadioSchedule
	instanceVariableNames: 'service day broadcasts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCRadioSchedule commentStamp: 'jrm 3/1/2014 12:52' prior: 0!
A BBCRadioSchedule is an object to manage a broadcast schedule for shows that are available to "Listen Again"

Instance Variables
	broadcasts:		<Object>
	day:		-- deprecate
	service:		--- change to outlet ??

broadcasts
	- xxxxx

day
	- xxxxx

service
	- xxxxx
!

!BBCRadioSchedule class methodsFor: 'as yet unclassified' stamp: 'jrm 3/1/2014 12:54'!
newFrom: aUrlStub

"A complete schedule of progerams available to be recorded requires access to two schedules, this_week and last_week. "

	"BBCRadioSchedule newFrom: 'http://www.bbc.co.uk/radio4extra/programmes/schedules/' "
	

	| scheduleWeeks schedule anXMLDocument service broadcastsDoc broadcasts aSchedule |
	
	aSchedule := self new.
	broadcasts := OrderedCollection new.
	scheduleWeeks := {'this_week.xml' . 'last_week.xml'}.

	scheduleWeeks do: [:each |
	schedule := (HTTPClient httpGet: aUrlStub, each).		
	anXMLDocument  := XMLDOMParser parseDocumentFrom: (schedule).
	service := (anXMLDocument firstTagNamed: #service) attributes at: #key.

	broadcastsDoc :=anXMLDocument firstTagNamed: #broadcasts.
	broadcastsDoc elementsAndContents do: [:every | broadcasts add: (BBCRadioBroadcast newFrom: every) ]].
	
	^ aSchedule service: service  broadcasts: broadcasts.
	! !

!BBCRadioSchedule methodsFor: 'as yet unclassified' stamp: 'jrm 2/7/2014 20:07'!
broadcasts
	"comment stating purpose of message"


	^ broadcasts! !

!BBCRadioSchedule methodsFor: 'as yet unclassified' stamp: 'jrm 2/23/2014 12:34'!
initialize
	


	! !

!BBCRadioSchedule methodsFor: 'as yet unclassified' stamp: 'jrm 3/1/2014 12:53'!
service: aService broadcasts: aBroadcasts
	"comment stating purpose of message"

	service := aService.
	broadcasts := aBroadcasts.! !

!BBCRadioSchedule methodsFor: 'as yet unclassified' stamp: 'jrm 2/4/2014 19:43'!
service: aService day: aDay broadcasts: aBroadcasts
	"comment stating purpose of message"

	service := aService.
	day := aDay.
	broadcasts := aBroadcasts.! !

Object subclass: #BBCRecorderApp
	instanceVariableNames: 'availabilitySchedule aSystemWindow aScrollPane aPasteUpMorph osp2'
	classVariableNames: 'DefaultOutlet DestinationFolder'
	poolDictionaries: ''
	category: 'BBCRadioRecorder'!

!BBCRecorderApp commentStamp: 'jrm 8/16/2014 16:01' prior: 0!
A BBCRecorderApp is An application to browse and record the Listen Again availability list for various BBC radio stations from outside the UK using the ffmpeg application.

Instance Variables
	aBBCRadioSchedule:		<Object>

availabilitySchedule
	- xxxxx
aBBCRadioWeeklySchedule
	- to be deprecated at some point
SystemWindow 
	- xxxxx
aPasteUpMorph 
	- xxxxx
osp2
	- is this needed as an instance var?


Class Variables

	DestinationFolder          Folder where recordings are written. User Selectable


Check for classes not longer required. There has bee a lot of hacking going on
BBCRadioAvailabilitySchedule allInstances
BBCRadioBroadcast allInstances
BBCRadioMediaSelector allInstances
BBCRadioProgramme allInstances
BBCRadioSchedule allInstances
BBCRecorderApp allInstances!

!BBCRecorderApp class methodsFor: 'initialize-release' stamp: 'jrm 2/7/2014 19:42'!
defaultDestination

"This will be used for insertion into a command string"
	^ DestinationFolder := '/Volumes/MediaVault/BBC/'! !

!BBCRecorderApp class methodsFor: 'initialize-release' stamp: 'jrm 2/7/2014 19:42'!
defaultOutlet

   	^ DefaultOutlet := 'radio4extra'! !

!BBCRecorderApp class methodsFor: 'initialize-release' stamp: 'jrm 8/31/2014 20:11'!
initialize

    "BBCRecorderApp initialize"

 	self defaultOutlet; defaultDestination; registerInWorldMenu.! !

!BBCRecorderApp class methodsFor: 'instance creation' stamp: 'jrm 3/1/2014 12:48'!
openAsMorph
"BBCRecorderApp openAsMorph "

	^self new openAsMorph! !

!BBCRecorderApp class methodsFor: 'initialize-release' stamp: 'jrm 3/1/2014 12:50'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'BBC Recorder' 
			with: (Array
				with: self
				with: #openAsMorph)) ].! !

!BBCRecorderApp class methodsFor: 'instance creation' stamp: 'jrm 1/17/2015 21:46'!
zOpenAsMorph
"BBCRecorderApp zOpenAsMorph "

	^self new zOpenAsMorph! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
buttonSelected

self halt.

! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
buttonSelected: aBBCRadioScheduleEntry

	| linkCollection linkItem mediaSelectorUrl |

"When the button is selected, we want to compose and execute a command line string that will execute a program that will transcribe the program string into an MP3 file that can be played on an iPod. The information we need in in the aBBCRadioScheduleEntry"

linkCollection := aBBCRadioScheduleEntry links.
linkCollection size = 1 ifTrue: [ linkItem := linkCollection at: 1 ] ifFalse: [ self halt: 'I only expect one element in the collection. The requirements have changed and will require analysis and programming to correct.'].

mediaSelectorUrl := linkItem url.

BBCRadioMediaselectorBuilder newFrom: mediaSelectorUrl.

self halt.

! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 3/1/2014 12:49'!
buttonSelected: aStringButtonMorph entrySelected: aBBCRadioBroadcast


	"When the button is selected, we want to compose and execute a command line string that will execute a program that will transcribe the program string into an MP3 file that can be played on an iPod. The information we need in in the aBBCRadioBroadcast"

	" aStringButtonMorph is not needed here unless I want to highlight it while this work is being done "

	"self buildCommandLineStringFor: aStringButtonMorph with:  aBBCRadioBroadcast "

	^ aBBCRadioBroadcast buildCommandLineString! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
composeFileNameFor: aString seriesCount: sCountString episode: episodeString
	"We need a fileName to use in the command line when we record a stream. The file name is based on the title of the stream and we offer the option to edit the title directly or select a file name from a directory and edit it. The second option is most useful for a series when all you want to do is update the episode or series numbers"
	| option editString fullString |
	

	"Clean up problem characters"
	editString := aString replaceAll: $' with: $-.
	editString := editString replaceAll: $:  with: $-.
	editString  := editString replaceAll: $/  with: $-.
	fullString := editString,'.', episodeString,'.', sCountString.
	"Ask for the desired option"
	option := UserDialogBoxMorph confirm: 'File Name for Stream' withCRs title: 'Create new, or look up existing?' trueChoice: 'Lookup' falseChoice: 'Create'.  
	option ifTrue: [ ^ self fileNameFromString: (self fileNameFromDirectory: fullString )] 
			ifFalse:[^ self fileNameFromString: fullString]! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:43'!
compressSchedule
	"Compress the schedule by removing multiple entries for a single title (shows
	are broadcast more than once"
	
	| aDictionary temp anOrderedCollection |
	
	aDictionary := Dictionary new.
	temp := availabilitySchedule episodes collect: [:each | aDictionary at: each title put: each].
	anOrderedCollection := OrderedCollection new.
	aDictionary valuesDo: [ :each | anOrderedCollection add: each].
	^ availabilitySchedule episodes: anOrderedCollection.
	! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 3/1/2014 12:48'!
currentSchedule
	""
	
	^ availabilitySchedule! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/12/2014 20:54'!
defaultOutlet
	
	
	^ 'radio4extra'! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 12/9/2014 07:18'!
fileNameFromDirectory
	" Let me select a name from a list so I can keep the file names for a list similar. I will edit the file 	name that I select in a later step"
	"BBCRecorderApp fileNameFromList"
	
	| fileList fileNameLIst fileName|
	fileList := (FileList newOn: (FileDirectory on: '/Volumes/MediaVault/BBC')) entriesMatching: '*.mp4'.
	fileNameLIst := fileList collect: [ :each | each name].
	fileName := ListChooser chooseItemFrom: fileNameLIst.
	"Strip file type indicator string .mp3 from end of file"
	^ fileName == nil ifTrue: [^fileName] ifFalse: [^ fileName copyFrom: 1 to: (fileName size -4)]
! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
fileNameFromDirectory: aString
	" Let me select a name from a list so I can keep the file names for a list similar. I will edit the file 	name that I select in a later step"
	"BBCRecorderApp fileNameFromList"
	
	| fileList fileNameLIst fileName|
	fileList := (FileList newOn: (FileDirectory on: '/Volumes/MediaVault/BBC')) entriesMatching: '*.mp3'.
	fileNameLIst := fileList collect: [ :each | each name].
	fileName := ListChooser chooseItemFrom: fileNameLIst title: 'Hint: ', aString.
	"Strip file type indicator string .mp3 from end of file"
	^ fileName == nil ifTrue: [^fileName] ifFalse: [^ fileName copyFrom: 1 to: (fileName size -4)]
! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
fileNameFromString: aString seriesCount: sCountString episode: episodeString
	"Modify the title string to create a useful file name to store the transcribed stream."
	| aNewString fileName |
" (BBCRecorderApp new) fileNameFromString: 'Some thing new: series 5 3.5'"

	"Dump spaces from aString"
	aNewString := aString  select: [ :each | each value ~= Character space].
	episodeString = nil ifTrue:[ fileName := aNewString ] ifFalse: [fileName := aNewString,'.', episodeString,'.', sCountString].
      fileName :=	FillInTheBlankMorph  request:  '.raw will be appended to file name' initialAnswer: fileName centerAt: 500@500.	
	fileName := '"',fileName,  '.raw','"'.

self halt.	
	! !

!BBCRecorderApp methodsFor: 'initalization' stamp: 'jrm 2/7/2014 19:42'!
initialize
	"comment stating purpose of message"
	! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
menuFiles
	"Display the file list for review. User can copy string if desired???"
	
	
	
self fileNameFromDirectory.

! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:39'!
menuOutlet
	"The BBC Radio Stations are called outlets. All we do here is get the new outlet and use it to set the aBBCRadioSchedule"
	

	
	
	| outlet |
	outlet := MenuMorph
		chooseFrom: #('radio4extra' 'radio4'  'radio3' 'radio2' '6music'  'radio1' '1xtra')
		values: #('radio4extra' 'radio4' 'radio3' 'radio2' '6music' 'radio1' '1xtra')
		lines: #()
		title: 'Outlet'.
	outlet = nil ifFalse: [
	 availabilitySchedule := (BBCRadioAvailability newFor: outlet).
	 aPasteUpMorph removeAllMorphs.
	self populateSchedule; compressSchedule.]
! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/7/2014 19:42'!
menuSort
	"Display a menu of sort options Alpha Date. Perform the sort"
	
	
	| sortMethod |
	sortMethod := MenuMorph
		chooseFrom: #('Alpha' 'Date')
		values: #('sortAlpha' 'sortDate')
		lines: #()
		title: 'Sort by'.
	self perform: sortMethod asSymbol.
	

! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:39'!
openAsMorph
	" eXperimenatl - refactoring to use BBCRadioAvailabilitySchedule.   create a BBC Radio Recorder Application on the BBC Radio4xtra schedule aScheduleMorph"
	
	"http://www.bbc.co.uk/radio1/programmes/schedules/england#on-now WTF"
	
	"BBCRecorderApp openAsMorph "
	| submorphExtent menuButton1 menuButton2 mbHolder menuButton3 |
	
	availabilitySchedule := BBCRadioAvailability newFor: (BBCRecorderApp defaultOutlet).
	aSystemWindow := SystemWindow labelled: 'BBC'.
	aSystemWindow model: self.

mbHolder := (RectangleMorph new) layoutPolicy: TableLayout new;
	  listDirection: #leftToRight;
	 wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap.
menuButton1 := SimpleButtonMorph new
		target: self ;
		label: 'Sort';
		actionSelector: #menuSort.
menuButton2 := (SimpleButtonMorph new
		target: self;
		label: 'Outlet';
		actionSelector: #menuOutlet;
		setBalloonText: 'Select a BBC Radio Outlet to display a list of available programs').
menuButton3 := (SimpleButtonMorph new
		target: self;
		label: 'FileNameReview';
		actionSelector: #menuFiles;
		setBalloonText: 'Take a look at the file names in the  current destination folder').
		
mbHolder addMorph: menuButton3; addMorph: menuButton1;addMorph: menuButton2.
aSystemWindow addMorph: mbHolder frame:  (0.0@0 corner: 1@0.007).
aPasteUpMorph := Morph new.
aPasteUpMorph color: Color veryVeryLightGray.

aPasteUpMorph layoutPolicy: TableLayout new;
	  listDirection: #topToBottom;
	 wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap.


aScrollPane := ScrollPane new.
aScrollPane scroller addMorph: aPasteUpMorph.
aPasteUpMorph on: #keyStroke send: #keyStroke: to: aScrollPane. 
aSystemWindow addMorph: aScrollPane frame: (0@0.07 extent: 1@0.93).
submorphExtent := aPasteUpMorph submorphBounds corner.
aScrollPane extent: submorphExtent.
aPasteUpMorph extent: submorphExtent; cellPositioning: #topLeft.
self populateSchedule.
aSystemWindow openInWorld.! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/22/2014 22:27'!
outletUrl: outlet
	"build the url using the value provided. If the value does not resolve correctl, there will be no file returned."

	outlet= 'radio4' ifTrue: [^ 'http://www.bbc.co.uk/radio4/programmes/schedules/fm/this_week.xml'].
	^ 'http://www.bbc.co.uk/', outlet, '/programmes/schedules/last_week.xml'! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 2/23/2014 10:54'!
outletUrlStub: outlet
	"Some of the BBC outlets have slightly different URLs. The final part of the complete string is this_week or last_week. Both URLs have to be accessed to get a complete list of programs available for recording."

	outlet= 'radio4' ifTrue: [^ 'http://www.bbc.co.uk/radio4/programmes/schedules/fm/'].

	^ 'http://www.bbc.co.uk/', outlet, '/programmes/schedules/'! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:43'!
populateSchedule
	"Build aPasteUpMorph and add individual program schedule morphs into it.. Run once when a new schedule is selected into currentSchedule  "
	
| aScheduleMorph |
	availabilitySchedule episodes do: [:each   | aScheduleMorph := each scheduleMorph. 
	aScheduleMorph on: #keyStroke send: #keyStroke: to: aScrollPane.
	aPasteUpMorph addMorph: (aScheduleMorph cellPositioning: #topLeft; target: self; actionSelector: #buttonSelected:entrySelected: ; arguments:  (Array with: aScheduleMorph with: each))].
! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:43'!
sortAlpha
	"Sort the pick list in alpha order"
	
	aPasteUpMorph submorphsDo: [:each | each delete].
	availabilitySchedule episodes:  (availabilitySchedule episodes sort: [:a :b | (a title, a availabilityLimit) > (b title, b availabilityLimit)]).

	self populateSchedule.! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 12/14/2015 19:14'!
sortDate
	"Sort the pick list in alpha order"
	
	aPasteUpMorph submorphsDo: [:each | each delete].
	availabilitySchedule 
		episodes:  (availabilitySchedule episodes  
			sort: [:a :b | (a availabilityStart) > (b availabilityStart)]).

	self populateSchedule.
	
! !

!BBCRecorderApp methodsFor: 'user interface' stamp: 'jrm 1/25/2015 14:39'!
zOpenAsMorph
	" experiment to test using category rather than scheduled"
	
	"BBCRecorderApp xOenAsMorph "
	| submorphExtent menuButton1 menuButton2 mbHolder menuButton3 |
	
	availabilitySchedule := BBCRadioAvailability newFromGenra: 'drama/crime'.
	aSystemWindow := SystemWindow labelled: 'BBC-Genra'.
	aSystemWindow model: self.

mbHolder := (RectangleMorph new) layoutPolicy: TableLayout new;
	  listDirection: #leftToRight;
	 wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap.
menuButton1 := SimpleButtonMorph new
		target: self ;
		label: 'Sort';
		actionSelector: #menuSort.
menuButton2 := (SimpleButtonMorph new
		target: self;
		label: 'Outlet';
		actionSelector: #menuOutlet;
		setBalloonText: 'Select a BBC Radio Outlet to display a list of available programs').
menuButton3 := (SimpleButtonMorph new
		target: self;
		label: 'FileNameReview';
		actionSelector: #menuFiles;
		setBalloonText: 'Take a look at the file names in the  current destination folder').
		
mbHolder addMorph: menuButton3; addMorph: menuButton1;addMorph: menuButton2.
aSystemWindow addMorph: mbHolder frame:  (0.0@0 corner: 1@0.007).
aPasteUpMorph := Morph new.
aPasteUpMorph color: Color veryVeryLightGray.

aPasteUpMorph layoutPolicy: TableLayout new;
	  listDirection: #topToBottom;
	 wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap.


aScrollPane := ScrollPane new.
aScrollPane scroller addMorph: aPasteUpMorph.
aPasteUpMorph on: #keyStroke send: #keyStroke: to: aScrollPane. 
aSystemWindow addMorph: aScrollPane frame: (0@0.07 extent: 1@0.93).
submorphExtent := aPasteUpMorph submorphBounds corner.
aScrollPane extent: submorphExtent.
aPasteUpMorph extent: submorphExtent; cellPositioning: #topLeft.
self populateSchedule.
aSystemWindow openInWorld.! !
BBCRadioAvailability initialize!
BBCRecorderApp initialize!
